<?php

    function yoda_tools_autoloader( $class_name ): void { 

        $namespace = 'yoda_tools';

        if (strpos($class_name, $namespace) !== 0) {
            return;
        }

        $class = str_replace($namespace, '', $class_name);
        $class = str_replace('\\', DIRECTORY_SEPARATOR, $class) . '.php';

        //$directory = get_template_directory();
        $path = YODA_TOOLS_PATH . DIRECTORY_SEPARATOR . $class;
        
        if (file_exists($path)) {
            require_once($path);
        }

        // If the file exists in the specified path, then include it.
        if ( file_exists( $path ) ) {
            require_once( $path );
        } else {
            wp_die(
                esc_html( "The file attempting to be loaded at $path does not exist." )
            );
        }
    }