<?php
    namespace yoda_tools\includes;

    /* Does User Belong Here */
    if (!defined('YODA_TOOLS_PATH')) {
        header('Status: 403 Forbidden');
        header('HTTP/1.1 403 Forbidden');
        exit();
    }

    class scripts
    {
        public function __construct(){ }

        public static function register(): void {

            // Set UI labels for Custom Post Type
            $labels = array(
                'name'                => _x('Scripts', 'Post Type General Name'),
                'singular_name'       => _x('Script', 'Post Type Singular Name'),
                'menu_name'           => __('Script Log'),
                'parent_item_colon'   => __('Parent Script'),
                'all_items'           => __('Scripts'),
                'view_item'           => __('View Script'),
                'add_new_item'        => __('Add New Script'),
                'add_new'             => __('Add New'),
                'edit_item'           => __('Edit Script'),
                'update_item'         => __('Update Script'),
                'search_items'        => __('Search Scripts'),
                'not_found'           => __('Not Found'),
                'not_found_in_trash'  => __('Not found in Trash'),
            );

            // Set other options for Custom Post Type
            $argsActions = array(
                'label'               => __('scripts'),
                'description'         => __('script'),
                'labels'              => $labels,
                'supports'            => array('title', 'editor'),
                'hierarchical'        => false,
                'public'              => false,
                'show_ui'             => false,
                'show_in_menu'        => false,
                'show_in_nav_menus'   => false,
                'show_in_admin_bar'   => false,
                'menu_position'       => false,
                'can_export'          => false,
                'has_archive'         => false,
                'exclude_from_search' => true,
                'publicly_queryable'  => false,
                'capability_type'     => 'post',
            );
            register_post_type('yoda-script', $argsActions);
            //Post type name must be less than 20 characters

            // Set UI labels for Custom Post Type
            $labels_php = array(
                'name'                => _x('Custom PHP', 'Post Type General Name'),
                'singular_name'       => _x('custom-php', 'Post Type Singular Name'),
                'menu_name'           => __('Custom PHP'),
                'parent_item_colon'   => __('Parent php'),
                'all_items'           => __('php'),
                'view_item'           => __('View php'),
                'add_new_item'        => __('Add New php'),
                'add_new'             => __('Add New'),
                'edit_item'           => __('Edit php'),
                'update_item'         => __('Update php'),
                'search_items'        => __('Search php'),
                'not_found'           => __('Not Found'),
                'not_found_in_trash'  => __('Not found in Trash'),
            );

            // Set other options for Custom Post Type
            $argsActions_php = array(
                'label'               => __('Custom PHP'),
                'description'         => __('Custom PHP'),
                'labels'              => $labels_php,
                'supports'            => array('title', 'editor'),
                'hierarchical'        => false,
                'public'              => false,
                'show_ui'             => false,
                'show_in_menu'        => false,
                'show_in_nav_menus'   => false,
                'show_in_admin_bar'   => false,
                'menu_position'       => false,
                'can_export'          => false,
                'has_archive'         => false,
                'exclude_from_search' => true,
                'publicly_queryable'  => false,
                'capability_type'     => 'post',
            );
            register_post_type('yoda-php', $argsActions_php);

            // Set UI labels for Custom Post Type
            $labels_css = array(
                'name'                => _x('Custom CSS', 'Post Type General Name'),
                'singular_name'       => _x('custom-css', 'Post Type Singular Name'),
                'menu_name'           => __('Custom CSS'),
                'parent_item_colon'   => __('Parent css'),
                'all_items'           => __('css'),
                'view_item'           => __('View css'),
                'add_new_item'        => __('Add New css'),
                'add_new'             => __('Add New'),
                'edit_item'           => __('Edit css'),
                'update_item'         => __('Update css'),
                'search_items'        => __('Search css'),
                'not_found'           => __('Not Found'),
                'not_found_in_trash'  => __('Not found in Trash'),
            );

            // Set other options for Custom Post Type
            $argsActions_css = array(
                'label'               => __('Custom CSS'),
                'description'         => __('Custom CSS'),
                'labels'              => $labels_css,
                'supports'            => array('title', 'editor'),
                'hierarchical'        => false,
                'public'              => false,
                'show_ui'             => false,
                'show_in_menu'        => false,
                'show_in_nav_menus'   => false,
                'show_in_admin_bar'   => false,
                'menu_position'       => false,
                'can_export'          => false,
                'has_archive'         => false,
                'exclude_from_search' => true,
                'publicly_queryable'  => false,
                'capability_type'     => 'post',
            );
            register_post_type('yoda-css', $argsActions_css);

            // Set UI labels for Custom Post Type
            $labels_meta = array(
                'name'                => _x('Custom Meta', 'Post Type General Name'),
                'singular_name'       => _x('custom-meta', 'Post Type Singular Name'),
                'menu_name'           => __('Custom Meta'),
                'parent_item_colon'   => __('Parent meta'),
                'all_items'           => __('meta'),
                'view_item'           => __('View meta'),
                'add_new_item'        => __('Add New meta'),
                'add_new'             => __('Add New'),
                'edit_item'           => __('Edit meta'),
                'update_item'         => __('Update meta'),
                'search_items'        => __('Search meta'),
                'not_found'           => __('Not Found'),
                'not_found_in_trash'  => __('Not found in Trash'),
            );

            // Set other options for Custom Post Type
            $argsActions_meta = array(
                'label'               => __('Custom Meta'),
                'description'         => __('Custom Meta'),
                'labels'              => $labels_meta,
                'supports'            => array('title', 'editor'),
                'hierarchical'        => false,
                'public'              => false,
                'show_ui'             => false,
                'show_in_menu'        => false,
                'show_in_nav_menus'   => false,
                'show_in_admin_bar'   => false,
                'menu_position'       => false,
                'can_export'          => false,
                'has_archive'         => false,
                'exclude_from_search' => true,
                'publicly_queryable'  => false,
                'capability_type'     => 'post',
            );
            register_post_type('yoda-meta', $argsActions_meta);

            add_action('add_meta_boxes_yoda-tools-script', [__NAMESPACE__ . '\scripts','script_location_metaboxes']);
            add_action('save_post_yoda-tools-script', [__NAMESPACE__ . '\scripts','script_save_post']);

            register_post_status( 'system', array(
                'label'                     => 'yoda-script',
                'public'                    => true,
                'exclude_from_search'       => false,
                'show_in_admin_all_list'    => true,
                'show_in_admin_status_list' => true,
                'label_count'               => _n_noop( 'System (%s)', 'System (%s)' ),
            ) );

            register_post_status( 'system', array(
                'label'                     => 'yoda-php',
                'public'                    => true,
                'exclude_from_search'       => false,
                'show_in_admin_all_list'    => true,
                'show_in_admin_status_list' => true,
                'label_count'               => _n_noop( 'System (%s)', 'System (%s)' ),
            ) );

            register_post_status( 'system', array(
                'label'                     => 'yoda-css',
                'public'                    => true,
                'exclude_from_search'       => false,
                'show_in_admin_all_list'    => true,
                'show_in_admin_status_list' => true,
                'label_count'               => _n_noop( 'System (%s)', 'System (%s)' ),
            ) );

            register_post_status( 'system', array(
                'label'                     => 'yoda-meta',
                'public'                    => true,
                'exclude_from_search'       => false,
                'show_in_admin_all_list'    => true,
                'show_in_admin_status_list' => true,
                'label_count'               => _n_noop( 'System (%s)', 'System (%s)' ),
            ) );

        }

        function script_location_metaboxes()
        {
            global $wp_meta_boxes;
            add_meta_box('postfunctiondiv', __('Function'), 'script_location_html', 'yoda-tools-script', 'normal', 'high');
        }

        function script_location_html(): void {
            global $post;
            $custom = get_post_custom($post->ID);
            $function = isset($custom["location"][0]) ? $custom["location"][0] : '';
            ?>
            <label for="function">Function:</label><input name="function" value="<?php echo $function; ?>" />
            <?php
        }

        function script_save_post(): void {
            if (empty($_POST)) return;
            global $post;
            update_post_meta($post->ID, "location", $_POST["location"]);
        }

    }

