const yodaAnSettings = (typeof yodaAdminNotices !== 'undefined') ? JSON.parse(yodaAdminNotices.yodaANSettings) : {};
const target_classes = [['success', 'updated'], 'error', 'warning', 'info'];
let target_data_classes = [];

/**
 *
 *
 * process notices elements
 * map the notices and check the settings to show to hide
 * @since 1.3.3
 *
 *
 */
const yoda_notices_el_process = (target_mainclass, obj) => {

    let status = null;
    let allclass = jQuery(obj).attr('class');

    if (target_data_classes.length > 0) {

        //check css selector
        if (yodaAnSettings.yoda_an_css_selector) {
            let selector = yodaAnSettings.yoda_an_css_selector.split(',');
            for (let s in selector) {
                let el = selector[s].replace('.', '');
                el = el.replace('#', '');
                if (jQuery(obj).hasClass(el)) {
                    status = 'custom_3';
                } else if (jQuery(obj).attr('id') === el) {
                    status = 'custom_3';
                }
            }
        }

        if (!status) {

            for (let y in target_data_classes) {
                switch (target_data_classes[y]) {
                    case "3":

                        if (Array.isArray(target_classes[y])) {
                            for (var i in target_classes[y]) {
                                if (jQuery(obj).hasClass(target_classes[y][i]) || jQuery(obj).hasClass('notice-'+target_classes[y][i])) {
                                    status = target_classes[y][i]+'_3';
                                }
                            }
                        } else {
                            if (jQuery(obj).hasClass(target_classes[y]) || jQuery(obj).hasClass('notice-'+target_classes[y])) {
                                status = target_classes[y]+'_3';
                            }
                        }

                        break;
                    case "2":

                        if (Array.isArray(target_classes[y])) {
                            for (var i in target_classes[y]) {
                                if (jQuery(obj).hasClass(target_classes[y][i]) || jQuery(obj).hasClass('notice-'+target_classes[y][i])) {
                                    status = target_classes[y][i]+'_2';
                                }
                            }
                        } else {
                            if (jQuery(obj).hasClass(target_classes[y]) || jQuery(obj).hasClass('notice-'+target_classes[y])) {
                                status = target_classes[y]+'_2';
                            }
                        }

                        break;
                }

            }

       }

    }

    switch (status) {
        case 'success_3':
        case 'updated_3':
        case 'error_3':
        case 'warning_3':
        case 'info_3':
        case 'custom_3':
            break;
        case 'success_2':
        case 'updated_2':
        case 'error_2':
        case 'warning_2':
        case 'info_2':
        case 'custom_2':
            jQuery(obj).remove();
            break;
        default:
            allclass = allclass.replace(target_mainclass,'');
            allclass = allclass.trim();
            let status_class = 'yoda-status-'+target_mainclass;

            let notice_html = jQuery(obj).html();
            //let's clean inline css
            // Parse HTML string into a DOM object
            let parser = new DOMParser();
            let doc = parser.parseFromString(notice_html, 'text/html');

            // Remove style attribute from all elements
            let elementsdiv = doc.querySelectorAll('*');
                elementsdiv.forEach(element => {
                element.removeAttribute('style');
                element.removeAttribute('class');
            });

            // Get HTML string without style attribute
            notice_html = doc.documentElement.innerHTML;

            jQuery(obj).find('.notice-dismiss').remove();
            jQuery('div.yoda_an_notice_widget').append('<div class="yoda_an_handler yoda_'+allclass+' '+status_class+'">'+notice_html+'</div>');
            jQuery(obj).remove();
            break;
    }
};
/**
 *
 *
 * yoda_widget_count
 * render notification count
 * @since 1.3.3
 *
 *
 */
const yoda_widget_count = () => {
    //assign count
    let count = 0;
    jQuery('.yoda_an_notice_widget').find('div.yoda_an_handler').each(function(){
        if (!jQuery(this).hasClass('hidden')) {
            count++;
        }
    });
    jQuery('#wp-admin-bar-yoda_an_tab_number').append('<span class="yoda_an_count">'+count+'</span>');
};
jQuery(document).ready(() => {

    let targets = ['error', 'notice', 'updated'];
    let admin_bar_h = jQuery('#wpadminbar').css('height');
    let admin_bar_h_num = jQuery('#wpadminbar').height();

    //match the screen height
    jQuery('div.yoda_an_notice_widget').css('margin-top', admin_bar_h);
    jQuery('div.yoda_an_notice_widget').css('height', 'calc(100vh - '+(admin_bar_h_num + 25)+'px)');

    if (yodaAnSettings) {
        target_data_classes = [yodaAnSettings.yoda_an_sln_options, yodaAnSettings.yoda_an_eln_options, yodaAnSettings.yoda_an_wln_options, yodaAnSettings.yoda_an_iln_options]; 
    }   


    jQuery('.yoda_an_wrapps div').each(function(){
        for (let x in targets) {
            if (jQuery(this).hasClass(targets[x])) {
                yoda_notices_el_process(targets[x], jQuery(this));
            }
        }
    });   
    

    jQuery('#wp-admin-bar-yoda_an_tab_number a').click((e) => {
        e.stopPropagation();
        jQuery('.yoda_an_notice_widget').toggleClass('yoda_an_open');
        return false;
    })


    jQuery('body').on('click', '.yoda_an_notice_widget', function(e){
        e.stopPropagation();
    });

    jQuery(document).click(function(){
        jQuery('.yoda_an_notice_widget').removeClass('yoda_an_open');
    });

    yoda_widget_count();
    
});

/**
 * 
 * 
 * capture system notification after page loaded
 * @since 1.3.3
 * 
 * 
*/
jQuery(window).load(() => {

    /**
     * 
     * custom notices from 3rd party plugins
     * 
     */
    if (yodaAnSettings.yoda_an_nln_options === '1') {
        jQuery('.notice').each(function(){
            var has_wrap = jQuery(this).closest('div.wrap');
            var has_yoda_wrap = jQuery(this).closest('div.yoda_an_wrapps');
            if (has_wrap.length === 0 && has_yoda_wrap.length === 0) {
                let allclass = jQuery(this).attr('class');
                allclass = allclass.replace('notice','');
                allclass = allclass.trim();
                jQuery(this).find('.notice-dismiss').remove();
                jQuery('div.yoda_an_notice_widget').append('<div class="yoda_an_handler yoda_'+allclass+'">'+jQuery(this).html()+'</div>');
                jQuery(this).remove();
            }
        });
    }

    if (yodaAnSettings.yoda_an_wpan_options === "1") {

        jQuery('.wrap').find('.notice').each(function(){
            let isplug = jQuery(this).closest('.plugin-update');
            let istheme = jQuery(this).closest('div.theme');
            if (isplug.length === 0 && !jQuery(this).hasClass('hidden') && istheme.length === 0) {
                yoda_notices_el_process('notice', jQuery(this));
            }
        });
        yoda_widget_count();

    }

});


