<?php
    use yoda_tools\includes\core\settings;
    use yoda_tools\includes\core\adminNotices;
    /* Does User Belong Here */
    if ( ! defined( 'YODA_TOOLS_VERSION' ) ) {
        header( 'Status: 403 Forbidden' );
        header( 'HTTP/1.1 403 Forbidden' );
        exit();
    }

    $yoda_options = settings::getInstance();
    $settings = $yoda_options->getOption('an-settings');

    $yoda_an_sln_options = (isset($settings['yoda_an_sln_options']))? $settings['yoda_an_sln_options'] : null;
    $yoda_an_eln_options = (isset($settings['yoda_an_eln_options']))? $settings['yoda_an_eln_options'] : null;
    $yoda_an_wln_options = (isset($settings['yoda_an_wln_options']))? $settings['yoda_an_wln_options'] : null;
    $yoda_an_iln_options = (isset($settings['yoda_an_iln_options']))? $settings['yoda_an_iln_options'] : null;
    $yoda_an_nln_options = (isset($settings['yoda_an_nln_options']))? $settings['yoda_an_nln_options'] : null;
    $yoda_an_css_selector = (isset($settings['yoda_an_css_selector']))? $settings['yoda_an_css_selector'] : null;
    $yoda_an_wpan_options = (isset($settings['yoda_an_wpan_options']))? $settings['yoda_an_wpan_options'] : null;
    $yoda_an_visibility_options = (isset($settings['yoda_an_visibility_options']))? $settings['yoda_an_visibility_options'] : null;

?>
<h2 class="yoda-nav-title"><?php esc_html_e('Admin Notices','yoda-tools'); ?></h2>

<div class="yoda-tab-content yoda-settings">
<form method="post" action="">
    <p><?php esc_html_e('Use the settings in this page to configure how the plugin should handle different types of admin notices. Refer to the introduction to admin notices for a detailed explanation about the different types of admin notices available in WordPress.','yoda-tools'); ?></p>
    <h3><?php esc_html_e('Standard admin notices','yoda-tools'); ?></h3>
    <table class="wp-list-table yoda_admin_notices_settings_table" cellspacing="0">
        <tr>
            <td valign="top">
                <b><?php esc_html_e('Success level notices','yoda-tools'); ?></b>
            </td>
            <td>
                <p>
                    <label>
                        <input type="radio" name="yoda_an_sln_options" value="1" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_sln_options, 1, 'checked', true)); ?> > <?php esc_html_e('Hide from the WordPress dashboard and show them in the plugin\'s popup', 'yoda-tools'); ?>
                    </label>
                </p>
                <p>
                    <label>
                        <input type="radio" name="yoda_an_sln_options" value="2" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_sln_options, 2, 'checked')); ?> > <?php esc_html_e('Hide them completely (do not show in the WordPress dashboard or in the plugin\'s popup)', 'yoda-tools'); ?>
                    </label>
                </p>
                <p>
                    <label><input type="radio" name="yoda_an_sln_options" value="3" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_sln_options, 3, 'checked')); ?>> <?php esc_html_e('Do not do anything (they will appear on the WordPress dashboard as per usual)', 'yoda-tools'); ?></label>
                </p>
            </td>
        </tr>
        <tr>
            <td valign="top">
                <b><?php esc_html_e('Error level notices', 'yoda-tools'); ?></b>
            </td>
            <td>
                <p>
                    <label>
                    <input type="radio" name="yoda_an_eln_options" value="1" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_eln_options, 1, 'checked', true)); ?>> <?php esc_html_e('Hide from the WordPress dashboard and show them in the plugin\'s popup', 'yoda-tools'); ?>
                    </label>
                </p>
                <p>
                    <label>
                        <input type="radio" name="yoda_an_eln_options" value="2" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_eln_options, 2, 'checked')); ?>> <?php esc_html_e('Hide them completely (do not show in the WordPress dashboard or in the plugin\'s popup)', 'yoda-tools'); ?>
                    </label>
                </p>
                <p>
                    <label><input type="radio" name="yoda_an_eln_options" value="3" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_eln_options, 3, 'checked')); ?>> <?php esc_html_e('Do not do anything (they will appear on the WordPress dashboard as per usual)', 'yoda-tools'); ?></label>
                </p>
            </td>
        </tr>

        <tr>
            <td valign="top">
                <b><?php esc_html_e('Warning level notices', 'yoda-tools'); ?></b>
            </td>
            <td>
                <p>
                    <label>
                        <input type="radio" name="yoda_an_wln_options" value="1" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_wln_options, 1, 'checked', true)); ?>> <?php esc_html_e('Hide from the WordPress dashboard and show them in the plugin\'s popup', 'yoda-tools'); ?>
                    </label>
                </p>
                <p>
                    <label>
                        <input type="radio" name="yoda_an_wln_options" value="2" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_wln_options, 2, 'checked')); ?>> <?php esc_html_e('Hide them completely (do not show in the WordPress dashboard or in the plugin\'s popup)', 'yoda-tools'); ?>
                    </label>
                </p>
                <p>
                    <label><input type="radio" name="yoda_an_wln_options" value="3" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_wln_options, 3, 'checked')); ?>> <?php esc_html_e('Do not do anything (they will appear on the WordPress dashboard as per usual)', 'yoda-tools'); ?></label>
                </p>
            </td>
        </tr>

        <tr>
            <td valign="top">
                <b><?php esc_html_e('Information level notices', 'yoda-tools'); ?></b>
            </td>
            <td>
                <p>
                    <label>
                    <input type="radio" name="yoda_an_iln_options" value="1" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_iln_options, 1, 'checked', true)); ?>> <?php esc_html_e('Hide from the WordPress dashboard and show them in the plugin\'s popup', 'yoda-tools'); ?>
                    </label>
                </p>
                <p>
                    <label>
                        <input type="radio" name="yoda_an_iln_options" value="2" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_iln_options, 2, 'checked')); ?>> <?php esc_html_e('Hide them completely (do not show in the WordPress dashboard or in the plugin\'s popup)', 'yoda-tools'); ?>
                    </label>
                </p>
                <p>
                    <label><input type="radio" name="yoda_an_iln_options" value="3" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_iln_options, 3, 'checked')); ?>> <?php esc_html_e('Do not do anything (they will appear on the WordPress dashboard as per usual)', 'yoda-tools'); ?></label>
                </p>
            </td>
        </tr>
    </table>

    <h3><?php esc_html_e('Non-Standard admin notices','yoda-tools'); ?></h3>
    <p><?php esc_html_e('These type of admin notices are typically created by third party plugins and themes and do not have any severity level. Use the below settings to configure how the plugin should handle these type of admin notices.', 'yoda-tools'); ?></p>

    <table class="wp-list-table yoda_admin_notices_settings_table" cellspacing="0">
        <tr>
            <td valign="top">
                <b><?php esc_html_e('No level notices','yoda-tools'); ?></b>
            </td>
            <td>
                <p>
                    <label>
                        <input type="radio" name="yoda_an_nln_options" value="1" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_nln_options, 1, 'checked')); ?>> <?php esc_html_e('Hide from the WordPress dashboard and show them in the plugin\'s popup', 'yoda-tools'); ?>
                    </label>
                </p>
                <p>
                    <label><input type="radio" name="yoda_an_nln_options" value="3" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_nln_options, 3, 'checked', true)); ?>> <?php esc_html_e('Do not do anything (they will appear on the WordPress dashboard as per usual)', 'yoda-tools'); ?></label>
                </p>
            </td>
        </tr>

        <tr>
            <td valign="top">
                <label for="yoda_an_css_selector"><b><?php esc_html_e('CSS selector','yoda-tools'); ?></b></label>
            </td>
            <td>
                <input type="text" name="yoda_an_css_selector" id="yoda_an_css_selector" placeholder=".sample-class or #sample-id" value="<?php echo esc_attr($yoda_an_css_selector); ?>"><br/>
                <?php esc_html_e('Plugin will ignore all notices matching this CSS selector. Use jQuery compatible CSS selector. You can specify multiple selectors and comma separate them.', 'yoda-tools'); ?>
            </td>
        </tr>
    </table>

    <h3><?php esc_html_e('WordPress system admin notices', 'yoda-tools'); ?></h3>
    <p><?php esc_html_e('These type of admin notices are used by WordPress to advise you about the status of specific actions, for example to confirm that the changed settings were saved, or that a plugin was successfully installed. It is recommended to let these admin notices appear in the WordPress dashboard.', 'yoda-tools'); ?></p>

    <table class="wp-list-table yoda_admin_notices_settings_table" cellspacing="0">
        <tr>
            <td valign="top">
                <b><?php esc_html_e('WordPress system admin notices','yoda-tools'); ?></b>
            </td>
            <td>
                <p>
                    <label>
                        <input type="radio" name="yoda_an_wpan_options" value="1" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_wpan_options, 1, 'checked')); ?>> <?php esc_html_e('Hide from the WordPress dashboard and show them in the plugin\'s popup', 'yoda-tools'); ?>
                    </label>
                </p>
                <p>
                    <label>
                        <input type="radio" name="yoda_an_wpan_options" value="2" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_wpan_options, 2, 'checked', true)); ?>> <?php esc_html_e('Do not do anything (they will appear on the WordPress dashboard as per usual)', 'yoda-tools'); ?> <b><?php esc_html_e('(Recommended)', 'yoda-tools'); ?></b>
                    </label>
                </p>
            </td>
        </tr>
    </table>

    <h3><?php esc_html_e('Hiding notifications','yoda-tools'); ?></h3>
    <p><?php esc_html_e('Plugin can hide the notifications from specific users or display them only to certain selected users. Use the below settings to configure this behaviour.','yoda-tools'); ?></p>

    <table class="wp-list-table yoda_admin_notices_settings_table" cellspacing="0">
        <tr>
            <td valign="top">
                <b><?php esc_html_e('Visibility','yoda-tools'); ?></b>
            </td>
            <td>
                <p>
                    <label>
                        <input type="radio" name="yoda_an_visibility_options" value="1" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_visibility_options, 1, 'checked', true)); ?>> <?php esc_html_e('Hide notifications from all users', 'yoda-tools'); ?>
                    </label>
                </p>
                <p>
                    <label>
                        <input type="radio" name="yoda_an_visibility_options" value="2" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_visibility_options, 2, 'checked')); ?>> <?php esc_html_e('Hide notifications only from these users', 'yoda-tools'); ?>
                    </label>
                </p>
                <select name="yoda_an_hide_to_users[]" class="yoda-an-select2" id="yoda_an_hide_to_users" multiple>
                    <?php
                        if (isset($settings['yoda_an_hide_to_users'])) {
                            foreach ($settings['yoda_an_hide_to_users'] as $user) {
                                $name = get_userdata($user);
                                ?>
                                <option value="<?php echo esc_attr($user); ?>" selected><?php echo esc_html($name->display_name); ?></option>
                                <?php
                            }
                        }
                    ?>
                </select>
                <br/><br/>
                <p>
                    <label>
                        <input type="radio" name="yoda_an_visibility_options" value="3" <?php echo esc_attr(adminNotices::set_field_status($yoda_an_visibility_options, 3, 'checked')); ?>> <?php esc_html_e('Hide notifications to all users but not these', 'yoda-tools'); ?><br/>
                    </label>
                </p>
                <select name="yoda_an_hide_not_to_users[]" class="yoda-an-select2" id="yoda_an_hide_not_to_users" multiple>
                    <?php
                        if (isset($settings['yoda_an_hide_not_to_users'])) {
                            foreach ($settings['yoda_an_hide_not_to_users'] as $user) {
                                $name = get_userdata($user);
                                ?>
                                <option value="<?php echo esc_attr($user); ?>" selected><?php echo esc_html($name->display_name); ?></option>
                                <?php
                            }
                        }
                    ?>
                </select>
            </td>
        </tr>
    </table>

    <br/>
    <input type="hidden" name="yoda_tool_page" value="yoda-tools-admin-notices">
    <input type="submit" class="button button-primary" value="Save Changes">
   
</form>