<?php 
    $credit_option_data = $this->options->getOption('credits');
    $ai_help_summary = $this->options->getOption('ai-help');
?>
<div class="yoda_credits_settings">
    <table class="form-table">
        <tr>
            <th width="30%"><?php esc_html_e('Credits remaining:'); ?></th>
            <td width="70%" class="yoda_credits_figure"><?php esc_html_e('Retrieving credits...'); ?></td>
        </tr>
        <?php 
            $yes_status = null;
            $no_status = null;
            if (!empty($credit_option_data['auto_process'])) {
                if ($credit_option_data['auto_process'] === 'Y') {
                    $yes_status = 'checked';
                } else {
                    $no_status = 'checked';
                }
            } else {
                $no_status = 'checked';
            }
        ?>
        <tr>
            <th><?php esc_html_e('Maennche tools will automatically process all found pending SEO Suggestions','yoda-tools'); ?></th>
            <td>
                <label><input type="radio" class="yoda_seo_auto_process_pending" name="yoda_seo_auto_process_pending" value="Y" <?php echo esc_attr($yes_status); ?>>&nbsp;<?php esc_attr_e('Yes','yoda_tools') ?></label>&nbsp;&nbsp;
                <label><input type="radio" class="yoda_seo_auto_process_pending" name="yoda_seo_auto_process_pending" value="N" <?php echo esc_attr($no_status); ?>>&nbsp;<?php esc_attr_e('No','yoda_tools') ?></label>
            </td>
        </tr>
        <tr>
            <th><?php esc_html_e('How do you apply your available credits?','yoda-tools'); ?></th>
            <td>
                <p>
                    <?php 
                        $all_status = null;
                        if (!empty($credit_option_data['credits'])) {
                            $all_status = ($credit_option_data['credits'] === 'all')? esc_attr('checked') : null;
                        } else {
                            $all_status = esc_attr('checked');
                        }
                    ?>
                    <label>
                        <input type="radio" class="yoda_credits_options" name="yoda_credits_options" value="all" <?php echo $all_status; ?>
                        >&nbsp;<?php esc_html_e('Apply all remaining credits', 'yoda-tools'); ?>
                    </label>
                </p>
                <p>
                    <?php 
                        $disabled = null;
                        $stop_status = null;
                        $stop_value = null;
                        $stop_remaining = null;
                        if (!empty($credit_option_data['credits'])) {
                            if ($credit_option_data['credits'] !== 'all') {
                                $stop_status = esc_attr('checked');

                                $credit_option = json_decode($credit_option_data['credits']);
                                $stop_value = (isset($credit_option[0]))? $credit_option[0] : null;
                                $stop_remaining = (isset($credit_option[1]))? $credit_option[1] : null;
                        
                            } else {
                                $disabled = esc_attr('disabled');
                            }   
                        }
                    ?>
                    <label>
                        <input type="radio" class="yoda_credits_options" name="yoda_credits_options" value="stop" <?php echo $stop_status; ?>>&nbsp;<?php esc_html_e('Stop at','yoda-tools') ?>&nbsp;<input type="number" id="yoda_credits_stop_at" placeholder="0" <?php echo $disabled; ?> value="<?php echo esc_attr($stop_value); ?>"><?php esc_html_e(' % left', 'yoda-tools'); ?> or <span class="yoda_credits_stop_figure" data-remaining="<?php echo esc_attr($stop_remaining); ?>"><?php echo ($stop_remaining)? esc_attr($stop_remaining) : '--'; ?></span>
                    </label>
                </p>
            </td>
        </tr>
        
        <tr>
            <th><?php wp_nonce_field( YODA_TOOLS_SLUG.'-tool-credits-nonce',YODA_TOOLS_SLUG.'-tool-credits-nonce' ); ?></th>
            <td><?php echo submit_button("Save Changes", "primary yoda_save_credit_settings"); ?></td>
        </tr>
    </table>
</div>
