<?php
    use yoda_tools\includes\core\settings;

    /* Does User Belong Here */
    if ( ! defined( 'YODA_TOOLS_VERSION' ) ) {
        header( 'Status: 403 Forbidden' );
        header( 'HTTP/1.1 403 Forbidden' );
        exit();
    }

    wp_enqueue_style('admin_css');
    $page = isset($_GET['page']) ? $_GET['page'] : '';

    $this->options = settings::getInstance();
    $mode_scripts = $this->options->getOption('mode-scripts');
    $mode_server = $this->options->getOption('mode-server-tools');
    $mode_seo_tools = $this->options->getOption('mode-seo-tools');
    $mode_smtp_tools = $this->options->getOption('mode-smtp-tools');
    $mode_spam_guard = $this->options->getOption('mode-spam-guard');
    $mode_admin_notices = $this->options->getOption('mode-admin-notices');
?>

<div class="yoda-wrap">
    <div class="yoda-nav yoda-dflex">
        <div class="headermenu">
            <img src="<?php echo YODA_TOOLS_URL . 'images/maennche-horizontal-full-color-150.jpg';?>" alt="Maennche Logo">
            <h1> Tools <small><?php echo 'v.' . get_option('yoda-tools_version'); ?></small></h1>
        </div>
        <ul class="yoda-dflex">
            <?php
            if($mode_scripts == 'on'){
                ?>
                    <li>
                        <a href="?page=yoda-tools-scripts" class="<?php echo ($page == 'yoda-tools-scripts' ? 'active' : ''); ?>">Scripts</a>
                    </li>
                <?php
            }
            if($mode_seo_tools == 'on'){
                ?>
                    <li>
                        <a href="?page=yoda-tools-seo-tools" class="<?php echo ($page == 'yoda-tools-seo-tools' ? 'active' : ''); ?>">SEO Tools</a>
                    </li>
                <?php
            }

            ?>
            <?php
            if($mode_server == 'on'){
                ?>
                    <li>
                        <a href="?page=yoda-tools-server-tools" class="<?php echo ($page == 'yoda-tools-server-tools' ? 'active' : ''); ?>">Server Tools</a>
                    </li>
                <?php
            }
            if($mode_smtp_tools == 'on'){
                ?>
                    <li>
                        <a href="?page=yoda-tools-smtp" class="<?php echo ($page == 'yoda-tools-smtp' ? 'active' : ''); ?>">SMTP</a>
                    </li>
                <?php
            }

            if ($mode_spam_guard == 'on') {
                ?>
                    <li>
                        <a href="?page=yoda-tools-spam-guard" class="<?php echo ($page == 'yoda-tools-spam-guard' ? 'active' : ''); ?>">Spam Guard</a>
                    </li>
                <?php
            }

            if ($mode_admin_notices == 'on') {
                ?>
                <li>
                    <a href="?page=yoda-tools-admin-notices" class="<?php echo ($page == 'yoda-tools-admin-notices' ? 'active' : ''); ?>">Admin Notices</a>
                </li>
                <?php
            }
            ?>

            <li>
                <a href="?page=yoda-tools-settings" class="<?php echo ($page == 'yoda-tools-settings' ? 'active' : ''); ?>">Settings</a>
            </li>
        </ul>
    </div>

    <div class="yoda-content">