<?php 
     use yoda_tools\includes\core\settings;
     /* Does User Belong Here */
     if ( ! defined( 'YODA_TOOLS_VERSION' ) ) {
        header( 'Status: 403 Forbidden' );
        header( 'HTTP/1.1 403 Forbidden' );
        exit();
    }


    $yoda_options = settings::getInstance();
    $connected = $this->options->getOption('apikey');

    $tab = (isset($_GET['tab']))? $_GET['tab'] : 'default';

    ?>
    <h2 class="yoda-nav-title"><?php esc_html_e('Settings','yoda-tools'); ?></h2>

    <ul class="yoda-tab yoda-dflex">
        <li><a href="?page=yoda-tools-settings" class="<?php echo ($tab === 'default' ? 'active' : ''); ?>"><?php esc_html_e('Maennche.com', 'yoda-tools'); ?></a></li>
        <li><a href="?page=yoda-tools-settings&tab=prev-version" class="<?php echo ($tab === 'prev-version' ? 'active' : ''); ?>"><?php esc_html_e('Preview Version', 'yoda-tools'); ?></a></li>
    </ul>
    <div class="yoda-tab-content yoda-settings">
        <?php switch ($tab) {

            case 'prev-version':
                ?>
                    <div class="yoda_form_content yoda_tools_settings_page_wrap">
                        <div class="update-message notice inline notice-success notice-alt yoda-message"></div>
                        <div>
                            <button class="button button-primary" id="yoda_tools_reset_transient_upgrader" data-nonce="<?php echo wp_create_nonce('yoda-preview-version'); ?>"><?php esc_html_e('Clear Update Transients','yoda-tools'); ?></button>
                            <p><?php esc_html_e('Clear the temporary cache to retrieve the most recent updates.', 'yoda-tools'); ?></p>
                        </div>
                        <div class="yoda_tools_preview_version">
                            <span class="dashicons dashicons-update upgrader_loader"></span> <?php esc_html_e('Checking preview version...','yoda-tools'); ?>
                        </div>
                    </div>

                    <!-- Preview version MODAL -->
                    <div class="yoda_tools_preview_modal">
                        <div class="yoda_tools_preview_content">
                            <h3><?php esc_html_e('WARNING', 'yoda-tools'); ?></h3>
                            <p><?php esc_html_e('Once the preview version is installed, it cannot be rolled back. You will need to await the release of the next stable version for any changes.','yoda-tools'); ?></p>
                            <button class="button button-primary" id="yoda_tools_proceed_to_get_preview" data-nonce="<?php echo wp_create_nonce('yoda-preview-version'); ?>"><?php esc_html_e('I understand and proceed','yoda-tools'); ?></button>&nbsp;&nbsp;<button class="button button-secondary" id="yoda_tools_cancel_preview"><?php esc_html_e('Cancel', 'yoda-tools'); ?></button>
                        </div>
                    </div>
                <?php
                break;
            default:

                if (empty($connected)) {
                    ?>
                    <div class="yoda_auth_response_message"></div>
                    <input type="hidden" name="yoda-tools-authenticate-step" class="step" value="4"/>

                    <table class="yoda_auth_details">
                        <tr>
                            <td>
                                <table class="form-table yoda_spam_log">
                                    <tr>
                                        <th><?php esc_html_e('Username','yoda-tools'); ?></th>
                                        <td><input class="regular-text" id="yoda_auth_username" type="text" name="yoda-tools-auth-username" autofocus="autofocus" required />
                                            <span></span>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th><?php esc_html_e('Password','yoda-tools'); ?></th>
                                        <td><input class="regular-text" id="yoda_auth_password" type="password" name="yoda-tools-auth-pass" required />
                                        <span></span>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th></th>
                                        <td><?php
                                            wp_nonce_field( YODA_TOOLS_SLUG.'-save-authenticate-nonce',YODA_TOOLS_SLUG.'-save-authenticate-nonce' );
                                            submit_button("Login", 'primary yoda_do_api_authentication');
                                        ?>  </td>

                                    </tr>

                                </table>
                            </td>

                            <td>
                                <?php if (empty($connected)) { ?>
                                    <div class="yoda_seo_with_murphy">
                                        <div class="yoda_seo_with_murphy_item">
                                            <p><?php esc_html_e('Hi, I am Senator Murphy.', 'yoda-tools'); ?></p>
                                            <p><?php esc_html_e('The AI behind Maennche.com.', 'yoda-tools'); ?><br/>
                                            <?php esc_html_e('I can assist with helping your website rank #1 on search engines.', 'yoda-tools'); ?><br/>
                                            <?php esc_html_e('I can also automagically make updates that help with ADA compliance.', 'yoda-tools'); ?></p>

                                            <p><?php esc_html_e('Some of the things I can do:', 'yoda-tools'); ?></p>
                                            <ul>
                                                <li><span class="dashicons dashicons-yes"></span> <?php esc_html_e('Create Page/Post Meta Titles','yoda-tools'); ?></li>
                                                <li><span class="dashicons dashicons-yes"></span> <?php esc_html_e('Create Page/Post Meta Descriptions','yoda-tools'); ?></li>
                                                <li><span class="dashicons dashicons-yes"></span> <?php esc_html_e('Create Page/Post Excerpts','yoda-tools'); ?></li>
                                                <li><span class="dashicons dashicons-yes"></span> <?php esc_html_e('Add Image Alt Text','yoda-tools'); ?></li>
                                                <li><span class="dashicons dashicons-yes"></span> <?php esc_html_e('Add title text to links','yoda-tools'); ?></li>
                                            </ul>
                                            <p><?php esc_html_e('If you do not have a Maennche.com account, you can create a free account by', 'yoda-tools'); ?> <a href="https://studio.maennche.com/register/"><?php esc_html_e('clicking here', 'yoda-tools'); ?></a></p>
                                        </div>
                                        <div class="yoda_seo_with_murphy_item"><img src="<?php echo YODA_TOOLS_URL ?>images/sm-waving.png" title="<?php esc_attr_e('YODA SEO Tools', 'yoda-tools'); ?>" alt="<?php esc_attr_e('YODA SEO Tools', 'yoda-tools'); ?>"></div>
                                    </div>
                                <?php } ?>
                            </td>
                        </tr>
                    </table>
                <?php } else { ?>
                    <input type="hidden" name="yoda-tools-tool-step" class="step" value="3"/>
                    <table>
                        <tr>
                            <td style="width:50%;">
                                <table class="form-table">
                                    <tr>
                                        <th width="30%"><?php esc_html_e('Connected', 'yoda-tools'); ?></th>
                                        <td width="70%">
                                            <?php
                                                wp_nonce_field( YODA_TOOLS_SLUG.'-tool-logout-nonce',YODA_TOOLS_SLUG.'-tool-logout-nonce' );
                                                submit_button("Logout", "primary yoda_do_api_logout");
                                            ?>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td colspan="2" class="yoda_credit_content">
                                            <?php require_once( YODA_TOOLS_PATH . '/views/credits.php' ); ?>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                            <td style="width:50%;">
                                <div>
                                    <h2>Looking for more?</h2>
                                    <p style="font-size: 16px;">
                                        Maennche Tools is only a small chip off of the iceberg we call Maennche Studios!<br><br>
                                        Technology is constantly changing and we are always having to adapting with it,
                                        but what good are those changes if you don’t know how to utilize them to your advantage?<br><br>
                                        <span style="color:#D63638;font-weight: bold;">We can help with that!</span><br><br>
                                        <a href="https://studio.maennche.com" target="_blank" style="width: 230px;height: 38px;background-color: #B32E25;padding: 5px 25px;border-radius: 5px;color: #fff;text-decoration: none;font-size: 16px;">Visit Us Here!</a>
                                    </p>
                                </div>
                            </td>
                        </tr>
                    </table>
                <?php }

                break;
        } ?>
    </div>