<?php
	use yoda_tools\includes\core\settings;
	use yoda_tools\includes\cron_tracking;
    use yoda_tools\includes\core\utilities;

    /* Does User Belong Here */
	if ( ! defined( 'YODA_TOOLS_VERSION' ) ) {
        header( 'Status: 403 Forbidden' );
        header( 'HTTP/1.1 403 Forbidden' );
        exit();
    }

    global $wpdb;
    $notifications = null;

    //Get the active tab from the $_GET param
    $tab = isset($_GET['tab']) ? $_GET['tab'] : '';

	$this->options = settings::getInstance();
    $mode_smtp_tools = $this->options->getOption('mode-smtp-tools');
	

    //configurations
    if (isset( $_POST[YODA_TOOLS_SLUG.'-save-configurations-nonce'] ) && wp_verify_nonce( $_POST[YODA_TOOLS_SLUG.'-save-configurations-nonce'], YODA_TOOLS_SLUG.'-save-configurations-nonce' ) ) {
        $fnStep = null;
        $transport_type = "";
        $smtp_mailers = "";
        $hostname = "";
        $port = "";
        $envelope_sender = "";
        $envelope_sender_name = "";
        $enc_type = "";
        $auth_type = "";
        $username = "";
        $password = "";
        $mailgun_api_key = "";
        $mailgun_domain_name = "";
        $mailgun_region = "";

        if ( isset( $_POST[ YODA_TOOLS_SLUG . '-register-step'] ) ) {
            $fnStep = utilities::clean_string( YODA_TOOLS_SLUG . '-register-step',false);
        }
        if ( isset( $_POST[ YODA_TOOLS_SLUG . '-transport_type'] ) ) {
            $transport_type = utilities::clean_string( YODA_TOOLS_SLUG . '-transport_type');
        }
        if ( isset( $_POST[ YODA_TOOLS_SLUG . '-smtp_mailers'] ) ) {
            $smtp_mailers = utilities::clean_string( YODA_TOOLS_SLUG . '-smtp_mailers');
        }
        if ( isset( $_POST[ YODA_TOOLS_SLUG . '-hostname'] ) ) {
            $hostname = utilities::clean_string( YODA_TOOLS_SLUG . '-hostname');
        }
        if ( isset( $_POST[ YODA_TOOLS_SLUG . '-port'] ) ) {
            $port = utilities::clean_string( YODA_TOOLS_SLUG . '-port');
        }
        if ( isset( $_POST[ YODA_TOOLS_SLUG . '-envelope_sender'] ) ) {
            $envelope_sender = utilities::clean_string( YODA_TOOLS_SLUG . '-envelope_sender');
        }
        if ( isset( $_POST[ YODA_TOOLS_SLUG . '-envelope_sender_name'] ) ) {
            $envelope_sender_name = utilities::clean_string( YODA_TOOLS_SLUG . '-envelope_sender_name');
        }
        if ( isset( $_POST[ YODA_TOOLS_SLUG . '-reply_to'] ) ) {
            $reply_to = utilities::clean_string( YODA_TOOLS_SLUG . '-reply_to');
        }
        //field for envelop sender
        if ($transport_type == 'smtp') {
            if ( isset( $_POST[ YODA_TOOLS_SLUG . '-envelope_sender_smtp']) ) {
                $envelope_sender = utilities::clean_string( YODA_TOOLS_SLUG . '-envelope_sender_smtp');
            }    
        }        

        if ( isset( $_POST[ YODA_TOOLS_SLUG . '-enc_type'] ) ) {
            $enc_type = utilities::clean_string( YODA_TOOLS_SLUG . '-enc_type');
        }
        if ( isset( $_POST[ YODA_TOOLS_SLUG . '-auth_type'] ) ) {
            $auth_type = utilities::clean_string( YODA_TOOLS_SLUG . '-auth_type');
        }
        if ( isset( $_POST[ YODA_TOOLS_SLUG . '-username'] ) ) {
            $username = utilities::clean_string( YODA_TOOLS_SLUG . '-username');
        }
        if ( isset( $_POST[ YODA_TOOLS_SLUG . '-password'] ) ) {
            //$password = md5(utilities::clean_string( YODA_TOOLS_SLUG . '-password'));
            //md5 is a one way encryption we need two way so that we can authenticate the SMTP
            $password = utilities::clean_string( YODA_TOOLS_SLUG . '-password');
            if (!empty($password)) {
                $password = utilities::ssl_encrypt(['data' => $password, 'action' => 'encrypt']);
            }
        }
        if ( isset( $_POST[ YODA_TOOLS_SLUG . '-mailgun_api_key'] ) ) {
            $mailgun_api_key = utilities::clean_string( YODA_TOOLS_SLUG . '-mailgun_api_key');
        }
        if ( isset( $_POST[ YODA_TOOLS_SLUG . '-mailgun_domain_name'] ) ) {
            $mailgun_domain_name = utilities::clean_string( YODA_TOOLS_SLUG . '-mailgun_domain_name');
        }
        if ( isset( $_POST[ YODA_TOOLS_SLUG . '-mailgun_region'] ) ) {
            $mailgun_region = utilities::clean_string( YODA_TOOLS_SLUG . '-mailgun_region');
        }

        if (!empty($fnStep)){
            switch($fnStep) {
                case '5':

                    if ( isset( $_POST[YODA_TOOLS_SLUG . '-site-id'] ) ) {
                        update_option(YODA_TOOLS_SLUG . '-site-id', sanitize_text_field( $_POST[YODA_TOOLS_SLUG . '-site-id'] ));
                    }

                    update_option(YODA_TOOLS_SLUG . '-transport_type', $transport_type);
                    update_option(YODA_TOOLS_SLUG . '-smtp_mailers', $smtp_mailers);
                    update_option(YODA_TOOLS_SLUG . '-hostname', $hostname);
                    update_option(YODA_TOOLS_SLUG . '-port', $port);
                    update_option(YODA_TOOLS_SLUG . '-envelope_sender', $envelope_sender);
                    update_option(YODA_TOOLS_SLUG . '-envelope_sender_name', $envelope_sender_name);
                    update_option(YODA_TOOLS_SLUG . '-reply_to', $reply_to);
                    update_option(YODA_TOOLS_SLUG . '-enc_type', $enc_type);
                    update_option(YODA_TOOLS_SLUG . '-auth_type', $auth_type);
                    update_option(YODA_TOOLS_SLUG . '-username', $username);
                    update_option(YODA_TOOLS_SLUG . '-password', $password);

                    update_option(YODA_TOOLS_SLUG . '-mailgun_api_key', $mailgun_api_key);
                    update_option(YODA_TOOLS_SLUG . '-mailgun_domain_name', $mailgun_domain_name);
                    update_option(YODA_TOOLS_SLUG . '-mailgun_region', $mailgun_region);

                    $notifications = "Updated successfully";

                    break;
            }
        }
    }
    ?>

    <div class="yoda-notice">
        <?php if(!empty($notifications)): ?>
            <div class="notice notice-success"> 
                <p><strong><?php echo $notifications; ?></strong></p>
            </div>
        <?php endif; ?>

        <?php settings_errors(); ?>
    </div>

<h2 class="yoda-nav-title">SMTP</h2>
<?php
if($mode_smtp_tools == 'on'){
?>
<ul class="yoda-tab yoda-dflex">
    <li><a href="?page=yoda-tools-smtp" class="<?php echo ($tab == '' ? 'active' : ''); ?>">Logs</a></li>
    <li><a href="?page=yoda-tools-smtp&tab=smtp_options" class="<?php echo ($tab == 'smtp_options' ? 'active' : ''); ?>">Configurations</a></li>
    <li><a href="?page=yoda-tools-smtp&tab=test_email" class="<?php echo ($tab == 'test_email' ? 'active' : ''); ?>">Send a Test Email</a></li>
</ul>
<?php
}
?>

<div class="yoda-tab-content yoda-server-tools no-border">
	<?php
        switch($tab):
            case 'test_email':
                if($mode_smtp_tools == 'on'){
                    $email = get_userdata(get_current_user_id());
                    ?>
                    <h2>Send Test Email</h2><br/>
                    <div class="email-container">
                        <fieldset>
                            <legend><?php echo __('Who is this message going to?', YODA_TOOLS_SLUG); ?></legend>
                            <p>
                                <?php echo __('This utility allows you to send an email message for testing.If there is a problem, SMTP will give up after 60 seconds.', YODA_TOOLS_SLUG);?>
                            </p><br/>
                            <label><?php echo __('Recipient Email Address', YODA_TOOLS_SLUG);?></label>
                            <?php
                                echo sprintf( '<div class="send__wrap"><input type="hidden" name="security" value="%6$s"><div class="button__wrap"><input type="text" name="mail" class="yoda-tools-email" value="'.$email->user_email.'"><button class="yoda-tools-test-email button button-primary">%2$s</button></div></div>', '', __( 'Send test email', YODA_TOOLS_SLUG ), 'send', '', __( 'comma-separated for multiple emails', YODA_TOOLS_SLUG ), wp_create_nonce( 'yoda-tools-test-email' ) );
                            ?>
                        </fieldset>
                    </div>
                    <?php
                }
            break;
        	case 'smtp_options':
                if($mode_smtp_tools == 'on'){
                $found = get_transient( YODA_TOOLS_SLUG . '-site-key');
                //$this->option = settings::getInstance();
                ?>
                    <form method="post" >
                        <h2>Transport</h2>
                        Choose SMTP or a vendor-specific API:
                        <input type="hidden" name="yoda-tools-register-step" class="step" value="5"/>
                        <table class="form-table">
                            <tr>
                                <th>Type</th>
                                <td>
                                    <select id="select_transport_type" class="select_transport_type" name="<?php echo YODA_TOOLS_SLUG;?>-transport_type">
                                        <option 
                                            class="select_transport_type_default" 
                                            value="default"
                                            <?php echo ($this->options->getOption('transport_type') == 'default') ? 'selected="selected"':'';?> 
                                        >Default</option>
                                        <option 
                                            class="select_transport_type_smtp" 
                                            <?php echo ($this->options->getOption('transport_type' ) == 'smtp') ? 'selected="selected"':'';?> 
                                            value="smtp">SMTP</option>
                                        <option 
                                            class="select_transport_type_mailgun_api" 
                                            <?php echo ($this->options->getOption('transport_type' ) == 'mailgun') ? 'selected="selected"':'';?> 
                                            value="mailgun">Mailgun API</option>
                                    </select>
                                </td>
                            </tr>
                            <tr>
                                <th>Mailer Type</th>
                                <td>
                                    <select id="select_smtp_mailers" class="select_smtp_mailers" name="<?php echo YODA_TOOLS_SLUG;?>-smtp_mailers">
                                        <option 
                                            class="select_type_phpmailer" 
                                            <?php echo ($this->options->getOption('smtp_mailers' ) == 'phpmailer') ? 'selected="selected"':'';?> 
                                            value="phpmailer">PHPMailer
                                        </option>
                                        <option 
                                            class="select_type_smtp" 
                                            <?php echo ($this->options->getOption('smtp_mailers' ) == 'smtp') ? 'selected="selected"':'';?> 
                                            value="smtp">PostSMTP</option>
                                    </select>
                                    <p class="description" id="mailer-type-description">Beta Feature: ONLY change this to <strong>PHPMailer</strong> only if you see <code>wp_mail</code> conflict message, conflicts when another plugin is activated, and <strong><u>sometimes</u></strong> your mail marked as spam.</p>
                                </td>
                            </tr>
                        </table>
                        <div id="smtp_config" class="transport_setting" style="<?php echo ($this->options->getOption('transport_type' ) == 'smtp') ? 'display:block;':'display:none;';?>">
                            <h2>Transport Settings</h2>
                            Configure the communication with the mail server.
                            <table class="form-table" role="presentation">
                                <tbody>
                                    <tr>
                                        <th scope="row">Outgoing Mail Server Hostname</th>
                                        <td><input type="text" 
                                            id="input_hostname" 
                                            name="<?php echo YODA_TOOLS_SLUG;?>-hostname" 
                                            class="ps-input" 
                                            value="<?php echo $this->options->getOption('hostname'); ?>" 
                                            size="40" 
                                            placeholder="Required" />
                                        </td>
                                    </tr>
                                    <tr>
                                        <th scope="row">Outgoing Mail Server Port</th>
                                        <td>
                                            <input type="text" 
                                                id="input_port" 
                                                name="<?php echo YODA_TOOLS_SLUG;?>-port" 
                                                value="<?php echo $this->options->getOption('port'); ?>" 
                                                placeholder="Required">
                                        </td>
                                    </tr>
                                    <tr>
                                        <th scope="row">Reply-To Email Address</th>
                                        <td>
                                            <input type="email" 
                                                id="input_reply_to" 
                                                name="<?php echo YODA_TOOLS_SLUG;?>-reply_to" 
                                                value="<?php echo $this->options->getOption('reply_to'); ?>" 
                                                size="40" 
                                                class="required" 
                                                placeholder="Required"><br>
                                            <span class="yodatools_input_description">Optional. This email address will be used in the 'Reply-To' field of the email. Leave it blank to use 'From' email as the reply-to value.</span>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th scope="row">Envelope-From Email Address</th>
                                        <td>
                                            <input type="email" 
                                                id="input_envelope_sender_email" 
                                                name="<?php echo YODA_TOOLS_SLUG;?>-envelope_sender_smtp" 
                                                value="<?php echo $this->options->getOption('envelope_sender'); ?>" 
                                                size="40" 
                                                class="required" 
                                                placeholder="Required"><br>
                                            <span class="yodatools_input_description">This address, like the <b>return address</b> printed on an envelope, identifies the account owner to the SMTP server. For reliable delivery, this domain must specify an <a target="_blank" href="https://www.mail-tester.com/spf/">SPF record</a> permitting the use of the SMTP server named above.</span>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th scope="row">Security</th>
                                        <td>
                                            <select id="input_enc_type" class="input_encryption_type" name="<?php echo YODA_TOOLS_SLUG;?>-enc_type">
                                                <option 
                                                    class="input_enc_type_none" 
                                                    value="none" 
                                                    <?php echo ($this->options->getOption('enc_type') == 'none') ? 'selected="selected"':'';?>>
                                                    None</option>
                                                <option 
                                                    class="input_enc_type_ssl" 
                                                    value="ssl"
                                                    <?php echo ($this->options->getOption('enc_type') == 'ssl') ? 'selected="selected"':'';?>>
                                                    SMTPS</option>
                                                <option 
                                                    class="input_enc_type_tls" 
                                                    value="tls"
                                                    <?php echo ($this->options->getOption('enc_type') == 'tls') ? 'selected="selected"':'';?>>
                                                    STARTTLS</option>
                                            </select>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th scope="row">Authentication</th>
                                        <td>
                                            <select id="input_auth_type" class="input_auth_type" name="<?php echo YODA_TOOLS_SLUG;?>-auth_type">
                                                <option 
                                                    class="input_auth_type_none" 
                                                    value="none"
                                                    <?php echo ($this->options->getOption('auth_type') == 'none') ? 'selected="selected"':'';?>>
                                                    None</option>
                                                <option 
                                                    class="input_auth_type_plain" 
                                                    value="plain"
                                                    <?php echo ($this->options->getOption('auth_type') == 'plain') ? 'selected="selected"':'';?>>
                                                    Plain</option>
                                                <option 
                                                    class="input_auth_type_login" 
                                                    value="login"
                                                    <?php echo ($this->options->getOption('auth_type') == 'login') ? 'selected="selected"':'';?>>
                                                    Login</option>
                                                <!-- <option class="input_auth_type_crammd5" value="crammd5">CRAM-MD5</option>
                                                <option class="input_auth_type_oauth2" value="oauth2">OAuth 2.0</option> -->
                                            </select>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                        <div id="password_settings" class="authentication_setting non-oauth2" style="<?php echo ($this->options->getOption('transport_type' ) == 'smtp' && ( $this->options->getOption('auth_type') == 'login' || $this->options->getOption('auth_type') == 'plain') ) ? 'display:block;':'display:none;';?>">
                            <h2>Authentication</h2>
                            Enter the account credentials.
                            <table class="form-table" role="presentation">
                                <tbody>
                                    <tr>
                                        <th scope="row">Username</th>
                                        <td>
                                            <input type="text" 
                                                id="input_basic_auth_username" 
                                                name="<?php echo YODA_TOOLS_SLUG;?>-username" 
                                                value="<?php echo $this->options->getOption('username'); ?>" 
                                                size="40" 
                                                class="required" 
                                                placeholder="Required"><br>
                                            <span class="input_description">The Username is usually the same as the Envelope-From Email Address.</span>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th scope="row">Password</th>
                                        <td>
                                            <input type="password" 
                                                id="input_basic_auth_password" 
                                                name="<?php echo YODA_TOOLS_SLUG;?>-password" 
                                                value="<?php echo utilities::ssl_encrypt(['data' => $this->options->getOption('password'), 'action' => 'decrypt']); ?>" 
                                                size="40" 
                                                class="required" 
                                                placeholder="Required"> 
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                        <div id="mailgun_settings" class="mailgun_settings non-basic non-oauth2" style="<?php echo ($this->options->getOption('transport_type' ) == 'mailgun') ? 'display:block;':'display:none;';?>">
                            <h2>Authentication</h2>
                            <p id="wizard_mailgun_auth_help">Create an account at <a href="https://mailgun.com" target="_blank">mailgun.com</a> and enter <a href="https://app.mailgun.com/app/domains/" target="_blank">an API key</a> below. </p>
                            <table class="form-table" role="presentation">
                                <tbody>
                                <tr>
                                    <th scope="row">Envelope-From Email Address</th>
                                    <td>
                                        <input type="email" 
                                            id="input_envelope_sender_email" 
                                            name="<?php echo YODA_TOOLS_SLUG;?>-envelope_sender" 
                                            value="<?php echo $this->options->getOption('envelope_sender'); ?>" 
                                            size="40" 
                                            class="required" 
                                            placeholder="Required"><br>
                                        <span class="yodatools_input_description">This address, like the <b>return address</b> printed on an envelope, identifies the account owner to the SMTP server. For reliable delivery, this domain must specify an <a target="_blank" href="https://www.mail-tester.com/spf/">SPF record</a> permitting the use of the SMTP server named above.</span>
                                    </td>
                                </tr>
                                <tr>
                                    <th scope="row">Envelope-From Name</th>
                                    <td>
                                        <input type="text" 
                                            id="input_envelope_sender_name" 
                                            name="<?php echo YODA_TOOLS_SLUG;?>-envelope_sender_name" 
                                            value="<?php echo $this->options->getOption('envelope_sender_name'); ?>" 
                                            size="40" 
                                            class="required" 
                                            placeholder="Required">
                                    </td>
                                </tr>
                                <tr>
                                    <th scope="row">API Key</th>
                                    <td>
                                        <input type="text" 
                                            autocomplete="off" 
                                            id="mailgun_api_key" 
                                            name="<?php echo YODA_TOOLS_SLUG;?>-mailgun_api_key" 
                                            value="<?php echo $this->options->getOption('mailgun_api_key'); ?>"  
                                            class="required" placeholder="Required">
                                    </td>
                                </tr>
                                <tr>
                                    <th scope="row">Domain Name</th>
                                    <td>
                                        <input type="text" 
                                            autocomplete="off" 
                                            id="mailgun_domain_name" 
                                            name="<?php echo YODA_TOOLS_SLUG;?>-mailgun_domain_name" 
                                            value="<?php echo $this->options->getOption('mailgun_domain_name'); ?>" 
                                            class="required" placeholder="Required">
                                    </td>
                                </tr>
                                <tr>
                                    <th scope="row">Mailgun Europe Region?</th>
                                    <td>
                                        <input type="checkbox" 
                                            id="mailgun_region" 
                                            <?php echo (!empty($this->options->getOption('mailgun_region'))) ? "checked=checked":"";?>
                                            name="<?php echo YODA_TOOLS_SLUG;?>-mailgun_region">
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                        <table>
                            <tbody>
                                <tr>
                                    <td>
                                        <?php
                                            wp_nonce_field( YODA_TOOLS_SLUG.'-save-configurations-nonce',YODA_TOOLS_SLUG.'-save-configurations-nonce' );
                                            submit_button();
                                        ?>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </form><br>
                <?php
                }else{
                ?>
                    <p>Make sure you enable option in <a href="?page=yoda-tools-dashboard">Dashboard</a> page</p>
                <?php
                }
            break;
        	default:
        		require_once('EmailLogTable.php');
        		break;

       	endswitch;
   	?>
</div><!-- end .yoda-tab-content -->